#include "graph.h"

void DC(SDL_Surface *ecran, int x, int y, int ray, int aff, SDL_Color couleur)
{
	SDL_Surface *car = SDL_CreateRGBSurface(SDL_HWSURFACE, 1, 1, 32, 0, 0, 0, 0);
	SDL_FillRect(car, NULL, SDL_MapRGB(car->format, couleur.r, couleur.g, couleur.b));
	int d = 0;
	int aff_hd = (aff/8)%2;
	int aff_hg = (aff/4)%2;
	int aff_bg = (aff/2)%2;
	int aff_bd = aff%2;
	int i, j;
	SDL_Rect t_pos;
	for(i = (x-ray); i <= (x+ray); i ++)
	{
		for(j = (y-ray); j <= (y+ray); j ++)
		{
			d = sqrt(((x-i)*(x-i)) + ((y-j)*(y-j)));
			if(d == ray && ((aff_hg&&i<=x&&j<=y)||(aff_hd&&i>=x&&j<=y)||(aff_bd&&i>=x&&j>=y)||(aff_bg&&i<=x&&j>=y)))
			{
				t_pos.x = i;
				t_pos.y = j;
				SDL_BlitSurface(car, NULL, ecran, &t_pos);
			}
		}
	}
	SDL_FreeSurface(car);
}

void add_px(int x, int y, SDL_Surface *ecran, SDL_Color couleur)
{
	SDL_Surface *px = SDL_CreateRGBSurface(SDL_HWSURFACE, 1, 1, 32, 0, 0, 0, 0);
	SDL_FillRect(px, NULL, SDL_MapRGB(px->format, couleur.r, couleur.g, couleur.b));
	SDL_Rect pos;
	pos.x = x;
	pos.y = y;
	SDL_BlitSurface(px, NULL, ecran, &pos);
	SDL_FreeSurface(px);
}

void trait(int x1, int y1, int x2, int y2, SDL_Surface *ecran, SDL_Color couleur)
{
	int dx, dy;
	dx = x2 - x1;
	if(dx != 0)
	{
		if(dx < 0)
		{
			int tx = x2, ty = y2;
			x2 = x1;y2 = y1;
			x1 = tx;y1 = ty;
			dx = x2 - x1;
		}
		if(dx > 0)
		{
			dy = y2 - y1;
			if(dy != 0)
			{
				if(dy > 0)
				{
					if(dx >= dy)
					{
						int e;
						e = dx;
						dx = (e * 2);
						dy *= 2;
						while(1)
						{
							add_px(x1, y1, ecran, couleur);
							x1 ++;
							if(x1 == x2)
							{
								break;
							}
							e -= dy;
							if(e < 0)
							{
								y1 ++;
								e += dx;
							}
						}
					}
					else
					{
						int e;
						e = dy;
						dy = e * 2;
						dx *= 2;
						while(1)
						{
							add_px(x1, y1, ecran, couleur);
							y1 ++;
							if(y1 == y2)
							{
								break;
							}
							e -= dx;
							if(e < 0)
							{
								x1 ++;
								e += dy;
							}
						}
					}
				}
				else
				{
					if(dx >= -dy)
					{
						int e;
						e = dx;
						dx = e * 2;
						dy *= 2;
						while(1)
						{
							add_px(x1, y1, ecran, couleur);
							x1 ++;
							if(x1 == x2)
							{
								break;
							}
							e += dy;
							if(e < 0)
							{
								y1 --;
								e += dx;
							}
						}
					}
					else
					{
						int e;
						e = dy;
						dy = e * 2;
						dx *= 2;
						while(1)
						{
							add_px(x1, y1, ecran, couleur);
							y1 --;
							if(y1 == y2)
							{
								break;
							}
							e += dx;
							if(e > 0)
							{
								x1 ++;
								e += dy;
							}
						}
					}
				}
			}
			else
			{
				if(dx > 0)
				{
					do
					{
						add_px(x1, y1, ecran, couleur);
						x1 ++;
					}while(x1 != x2);
				}
				else
				{
					do
					{
						add_px(x1, y1, ecran, couleur);
						x1 --;
					}while(x1 != x2);
				}
			}
		}
	}
	else
	{
		dy = y2 - y1;
		if(dy != 0)
		{
			if(dy > 0)
			{
				do
				{
					add_px(x1, y1, ecran, couleur);
					y1 ++;
				}while(y1 != y2);
			}
			else
			{
				do
				{
					add_px(x1, y1, ecran, couleur);
					y1 --;
				}while(y1 != y2);
			}
		}
	}
}
