#ifndef DEF_HEADER_KTDS
#define DEF_HEADER_KTDS

#include <stdio.h>
#include <stdlib.h>
#include <SDL/SDL.h>

#define MAX_TAB 30000

typedef struct
{
	int *tab;
	int indice;
	int is_com;
	int is_fct;
	int fct_up;
	int saved_val;
	int saved_vals[10];
	
	int *fct_id;
	int *fct_start;
	int *fct_end;
	int fct_max;
	int for_i;
	
	int is_trait;
	
	SDL_Color couleur;
	
	int x[2];
	int y[2];
	
	SDL_Surface *ecran;
} Gest;

Gest *CreateTab();

int readCar(Gest *tab, char car, FILE *fich);

void makeBoucle(Gest *tab, FILE *fich);

void makeFor(Gest *tab, FILE *fich);

int callFct(Gest *tab, FILE *fich);

int add_fct(Gest *tab, FILE *fich);

int defPoint(Gest *tab, FILE *fich, int point_id);

int defCouleur(Gest *tab, FILE *fich);

int defTrait(Gest *tab, FILE *fich);

int defCercle(Gest *tab, FILE *fich);

void FreeTab(Gest *tab);

#endif
