/*
Kevin Trancho Drawing Script

>: répertoire suivant
<: répertoire précédent
0: répertoire 0

+: ajouter 1
-: retirer 1
o: définir à 0
2: multiplier par 2
5: division entière par 2

.: afficher caractère
:: afficher entier
,: recevoir caractère
;: recevoir entier

[instructions]: boucle while
f[instructions]: boucle for (on peut mettre des instructions juste après le f pour définir le nombre de tours à faire)
/instructions\: instructions en commentaire

~[instructions]: création d'une fonction ayant pour identifiant la valeur avant création
#: appel de fonction ayant pour identifiant la valeur avant appel

^: sauvergarde de valeur temporaire
v: récupération de valeur temporaire
ni: sauvergarde de valeur temporaire d'id i € [0, 9]
ui: récupération de valeur temporaire d'id i € [0, 9]

|&X&|: création d'un trait (valeur avant & => coordonnée x, valeur après & coordonnée y) (X séparateur de points)
(&X||||): création d'un cercle (valeur avant & => coordonnée x du centre, valeur après & coordonnée y du centre) (remplacer | par o pour effacer un quart du cercle)
(la valeur avant le ')' est le rayon du cercle)
{&&}: définir couleur en RGB (& séparteur entre valeur de couleur)
*/

/*
gcc *.c -o ktds `sdl-config --cflags --libs` -lm
*/

#include "ktds.h"

int main(int argc, char *argv[])
{
	if(argc > 1)
	{
		SDL_Init(SDL_INIT_VIDEO);
		Gest *tab = CreateTab();
		FILE *fich = fopen(argv[1], "r");
		if(fich != NULL)
		{
			fseek(fich, 0, SEEK_END);
			int limite = ftell(fich);
			rewind(fich);
			char car;
			while(ftell(fich) < limite)
			{
				car = fgetc(fich);
				if(readCar(tab, car, fich))
				{
				}
			}
			putchar('\n');
		}
		else
			printf("\"%s\" fichier invalide\n", argv[1]);
		/*int i = 0;
		for(i = 0; i < tab->fct_max; i ++)
		{
			printf("%d>(%d, %d)\n", tab->fct_id[i], tab->fct_start[i], tab->fct_end[i]);
		}*/
		SDL_Event event;
		do
		{
			SDL_WaitEvent(&event);
		}while(!(event.type == SDL_QUIT || (event.type == SDL_KEYDOWN && event.key.keysym.sym == SDLK_ESCAPE)));
		FreeTab(tab);
		SDL_Quit();
	}
	else
		printf("Utilisez de la manière:\n\"%s [FICHIER.ktds]\"\n", argv[0]);
	exit(EXIT_SUCCESS);
}
