#include "ktds.h"

Gest *CreateTab()
{
	Gest *tab = malloc(sizeof(Gest));
	tab->tab = calloc(MAX_TAB, sizeof(int));
	tab->fct_id = calloc(MAX_TAB, sizeof(int));
	tab->fct_start = calloc(MAX_TAB, sizeof(int));
	tab->fct_end = calloc(MAX_TAB, sizeof(int));
	tab->indice = 0;
	tab->is_com = 0;
	tab->is_fct = 0;
	tab->fct_up = 0;
	tab->fct_max = 0;
	tab->saved_val = 0;
	tab->is_trait = 0;
	tab->couleur.r = 255;
	tab->couleur.g = 255;
	tab->couleur.b = 255;
	tab->for_i = 0;
	tab->ecran = SDL_SetVideoMode(800, 600, 32, SDL_HWSURFACE);
	return tab;
}

int readCar(Gest *tab, char car, FILE *fich)
{
	if(tab->is_com)
	{
		if(car == '\\')
			tab->is_com = 0;
	}
	else if(tab->is_fct)
	{
		if(car == ']')
		{
			tab->fct_up --;
			if(tab->fct_up == 0)
			{
				tab->is_fct = 0;
				tab->fct_end[tab->fct_max-1] = ftell(fich);
			}
		}
		else if(car == '[')
		{
			/*if(tab->fct_up == 0)
				tab->fct_start[tab->fct_max] = ftell(fich);*/
			tab->fct_up ++;
		}
	}
	else
	{
		switch(car)
		{
			case '>':
			tab->indice ++;
			if(tab->indice >= MAX_TAB)
				tab->indice = 0;
			break;
			case '<':
			tab->indice --;
			while(tab->indice < 0)
				tab->indice += MAX_TAB;
			break;
			case '0':
			tab->indice = 0;
			break;
			case '+':
			tab->tab[tab->indice] = tab->tab[tab->indice]+1;
			break;
			case '-':
			tab->tab[tab->indice] = tab->tab[tab->indice]-1;
			break;
			case 'o':
			tab->tab[tab->indice] = 0;
			break;
			case '2':
			tab->tab[tab->indice] = tab->tab[tab->indice]*2;
			break;
			case '5':
			tab->tab[tab->indice] = tab->tab[tab->indice]/2;
			break;
			case '.':
			putchar(tab->tab[tab->indice]);
			break;
			case ':':
			printf("%d", tab->tab[tab->indice]);
			break;
			case ',':
			tab->tab[tab->indice] = getchar();
			break;
			case ';':
			scanf("%d", &(tab->tab[tab->indice]));
			break;
			case '[':
			makeBoucle(tab, fich);
			break;
			case 'f':
			makeFor(tab, fich);
			break;
			case '/':
			tab->is_com = 1;
			break;
			case '~':
			tab->is_fct = 1;
			tab->fct_up = 0;
			if(!add_fct(tab, fich))
			{
				printf("Redefinition of ~%d\n", tab->tab[tab->indice]);
			}
			break;
			case '#':
			if(!callFct(tab, fich))
			{
				printf("Unknown ~%d\n", tab->tab[tab->indice]);
			}
			break;
			case '^':
			tab->saved_val = tab->tab[tab->indice];
			break;
			case 'v':
			tab->tab[tab->indice] = tab->saved_val;
			break;
			case 'n':
			car = fgetc(fich);
			if(car >= '0' && car <= '9')
				tab->saved_vals[car-'0'] = tab->tab[tab->indice];
			else
				fseek(fich, ftell(fich)-1, SEEK_SET);
			break;
			case 'u':
			car = fgetc(fich);
			if(car >= '0' && car <= '9')
				tab->tab[tab->indice] = tab->saved_vals[car-'0'];
			else
				fseek(fich, ftell(fich)-1, SEEK_SET);
			break;
			case '|':
			if(tab->is_trait)
				return 0;
			tab->is_trait = 1;
			defTrait(tab, fich);
			break;
			case '(':
			defCercle(tab, fich);
			break;
			case '{':
			defCouleur(tab, fich);
			break;
			default:
			return 0;
		}
	}
	return 1;
}

void makeBoucle(Gest *tab, FILE *fich)
{
	int start = ftell(fich);
	int up = 1;
	char car = 0;
	do
	{
		car = fgetc(fich);
		if(car == '[')
			up ++;
		if(car == ']')
			up --;
	}while(up > 0 && car != ']');
	int end = ftell(fich);
	fseek(fich, start, SEEK_SET);
	while(tab->tab[tab->indice]>0)
	{
		fseek(fich, start, SEEK_SET);
		while(ftell(fich) < end)
		{
			car = fgetc(fich);
			if(readCar(tab, car, fich))
			{
			}
		}
	}
	fseek(fich, end, SEEK_SET);
}

void makeFor(Gest *tab, FILE *fich)
{
	char car = 0;
	do
	{
		car = fgetc(fich);
		if(car == '[')
			break;
	}
	while(readCar(tab, car, fich));
	int lim = tab->tab[tab->indice];
	tab->for_i = 0;
	int start = ftell(fich);
	int up = 1;
	do
	{
		car = fgetc(fich);
		if(car == '[')
			up ++;
		if(car == ']')
			up --;
	}while(up > 0 && car != ']');
	int end = ftell(fich);
	fseek(fich, start, SEEK_SET);
	while(tab->for_i < lim)
	{
		fseek(fich, start, SEEK_SET);
		while(ftell(fich) < end)
		{
			car = fgetc(fich);
			if(readCar(tab, car, fich))
			{
			}
		}
		tab->for_i ++;
	}
	fseek(fich, end, SEEK_SET);
}

int callFct(Gest *tab, FILE *fich)
{
	int act_pos = ftell(fich);
	int i = 0;
	int fid = 0;
	char car = 0;
	for(i = 0; i < tab->fct_max; i ++)
	{
		if(tab->tab[tab->indice] == tab->fct_id[i])
		{
			fid = i;
			break;
		}
	}
	if(i >= tab->fct_max)
		return 0;
	fseek(fich, tab->fct_start[fid], SEEK_SET);
	while(ftell(fich) < tab->fct_end[fid])
	{
		car = fgetc(fich);
		if(readCar(tab, car, fich))
		{
		}
	}
	fseek(fich, act_pos, SEEK_SET);
	return 1;
}

int add_fct(Gest *tab, FILE *fich)
{
	int i = 0;
	for(i = 0; i < tab->fct_max; i ++)
	{
		if(tab->tab[tab->indice] == tab->fct_id[i])
		{
			tab->is_fct = 0;
			return 0;
		}
	}
	tab->fct_id[tab->fct_max] = tab->tab[tab->indice];
	tab->fct_start[tab->fct_max] = ftell(fich)+1;
	tab->fct_max ++;
	return 1;
}

int defPoint(Gest *tab, FILE *fich, int point_id)
{
	char car = 0;
	do
	{
		car = fgetc(fich);
	}
	while(readCar(tab, car, fich));
	tab->x[point_id] = tab->tab[tab->indice];
	if(car != '&')
		return 0;
	do
	{
		car = fgetc(fich);
	}
	while(readCar(tab, car, fich));
	tab->y[point_id] = tab->tab[tab->indice];
	return car;
}

int defCouleur(Gest *tab, FILE *fich)
{
	char car = 0;
	do
	{
		car = fgetc(fich);
	}
	while(readCar(tab, car, fich));
	tab->couleur.r = tab->tab[tab->indice];
	if(car != '&')
		return 0;
	do
	{
		car = fgetc(fich);
	}
	while(readCar(tab, car, fich));
	tab->couleur.g = tab->tab[tab->indice];
	if(car != '&')
		return 0;
	do
	{
		car = fgetc(fich);
	}
	while(readCar(tab, car, fich));
	tab->couleur.b = tab->tab[tab->indice];
	return car;
}

int defTrait(Gest *tab, FILE *fich)
{
	char car = defPoint(tab, fich, 0);
	if(car == 'X')
	{
		if(defPoint(tab, fich, 1) == '|')
		{
			trait(tab->x[0], tab->y[0], tab->x[1], tab->y[1], tab->ecran, tab->couleur);
			SDL_Flip(tab->ecran);
			tab->is_trait = 0;
			return 1;
		}
	}
	tab->is_trait = 0;
	return 0;
}

int defCercle(Gest *tab, FILE *fich)
{
	char car = defPoint(tab, fich, 0);
	int val = 0;
	if(car == 'X')
	{
		int i = 0;
		for(i = 0; i < 4; i ++)
		{
			car = fgetc(fich);
			val*=2;
			if(car == '|')
				val ++;
		}
	}
	do
	{
		car = fgetc(fich);
	}
	while(readCar(tab, car, fich));
	if(car == ')')
	{
		DC(tab->ecran, tab->x[0], tab->y[0], tab->tab[tab->indice], val, tab->couleur);
		SDL_Flip(tab->ecran);
		return 1;
	}
	return 0;
}

void FreeTab(Gest *tab)
{
	SDL_FreeSurface(tab->ecran);
	free(tab->fct_id);
	free(tab->fct_start);
	free(tab->fct_end);
	free(tab->tab);
	free(tab);
}
